Package weka.classifiers.meta

# Class Decorate

java.lang.Object
weka.classifiers.Classifier
weka.classifiers.SingleClassifierEnhancer
weka.classifiers.IteratedSingleClassifierEnhancer
weka.classifiers.RandomizableIteratedSingleClassifierEnhancer
weka.classifiers.meta.Decorate

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `CapabilitiesHandler`, `OptionHandler`, `Randomizable`, `RevisionHandler`, `TechnicalInformationHandler`

public class Decorate extends RandomizableIteratedSingleClassifierEnhancer implements TechnicalInformationHandler
DECORATE is a meta-learner for building diverse ensembles of classifiers by using specially constructed artificial training examples. Comprehensive experiments have demonstrated that this technique is consistently more accurate than the base classifier, Bagging and Random Forests.Decorate also obtains higher accuracy than Boosting on small training sets, and achieves comparable performance on larger training sets.
For more details see:
P. Melville, R. J. Mooney: Constructing Diverse Classifier Ensembles Using Artificial Training Examples. In: Eighteenth International Joint Conference on Artificial Intelligence, 505-510, 2003.
P. Melville, R. J. Mooney (2004). Creating Diversity in Ensembles Using Artificial Data. Information Fusion: Special Issue on Diversity in Multiclassifier Systems..

BibTeX:

     @inproceedings{Melville2003,
        author = {P. Melville and R. J. Mooney},
        booktitle = {Eighteenth International Joint Conference on Artificial Intelligence},
        pages = {505-510},
        title = {Constructing Diverse Classifier Ensembles Using Artificial Training Examples},
        year = {2003}
     }

     @article{Melville2004,
        author = {P. Melville and R. J. Mooney},
        journal = {Information Fusion: Special Issue on Diversity in Multiclassifier Systems},
        note = {submitted},
        title = {Creating Diversity in Ensembles Using Artificial Data},
        year = {2004}
     }

Valid options are:

     -E
      Desired size of ensemble.
      (default 15)

     -R
      Factor that determines number of artificial examples to generate.
      Specified proportional to training set size.
      (default 1.0)

     -S <num>
      Random number seed.
      (default 1)

     -I <num>
      Number of iterations.
      (default 50)

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

     -W
      Full name of base classifier.
      (default: weka.classifiers.trees.J48)

     Options specific to classifier weka.classifiers.trees.J48:

     -U
      Use unpruned tree.

     -C <pruning confidence>
      Set confidence threshold for pruning.
      (default 0.25)

     -M <minimum number of instances>
      Set minimum number of instances per leaf.
      (default 2)

     -R
      Use reduced error pruning.

     -N <number of folds>
      Set number of folds for reduced error
      pruning. One fold is used as pruning set.
      (default 3)

     -B
      Use binary splits only.

     -S
      Don't perform subtree raising.

     -L
      Do not clean up after the tree has been built.

     -A
      Laplace smoothing for predicted probabilities.

     -Q <seed>
      Seed for random data shuffling (default 1).

Options after -- are passed to the designated classifier.

Version:
  $Revision: 8037 $
Author:
  Prem Melville (melville@cs.utexas.edu)
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`Decorate()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`String`
`artificialSizeTipText()`
Returns the tip text for this property
`void`
`buildClassifier(Instances data)`
Build Decorate classifier
`String`
`desiredSizeTipText()`
Returns the tip text for this property
`double[]`
`distributionForInstance(Instance instance)`
Calculates the class membership probabilities for the given test instance.
`double`
`getArtificialSize()`
Factor that determines number of artificial examples to generate.
`Capabilities`
`getCapabilities()`
Returns default capabilities of the classifier.
`int`
`getDesiredSize()`
Gets the desired size of the committee.
`String[]`
`getOptions()`
Gets the current settings of the Classifier.
`String`
`getRevision()`
Returns the revision string.
`TechnicalInformation`
`getTechnicalInformation()`
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`String`
`globalInfo()`
Returns a string describing classifier
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`numIterationsTipText()`
Returns the tip text for this property
`void`
`setArtificialSize(double newArtSize)`
Sets factor that determines number of artificial examples to generate.
`void`
`setDesiredSize(int newDesiredSize)`
Sets the desired size of the committee.
`void`
`setOptions(String[] options)`
Parses a given list of options.
`String`
`toString()`
Returns description of the Decorate classifier.

### Methods inherited from class weka.classifiers.RandomizableIteratedSingleClassifierEnhancer

`getSeed, seedTipText, setSeed`

### Methods inherited from class weka.classifiers.IteratedSingleClassifierEnhancer

`getNumIterations, setNumIterations`

### Methods inherited from class weka.classifiers.SingleClassifierEnhancer

`classifierTipText, getClassifier, setClassifier`

### Methods inherited from class weka.classifiers.Classifier

`classifyInstance, debugTipText, forName, getDebug, makeCopies, makeCopy, setDebug`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Decorate

public Decorate()
Constructor.

## Method Details

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options

Specified by:
  `listOptions` in interface `OptionHandler`
Overrides:
  `listOptions` in class `RandomizableIteratedSingleClassifierEnhancer`
Returns:
  an enumeration of all the available options

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -E
      Desired size of ensemble.
      (default 15)

     -R
      Factor that determines number of artificial examples to generate.
      Specified proportional to training set size.
      (default 1.0)

     -S <num>
      Random number seed.
      (default 1)

     -I <num>
      Number of iterations.
      (default 50)

     -D
      If set, classifier is run in debug mode and
      may output additional info to the console

     -W
      Full name of base classifier.
      (default: weka.classifiers.trees.J48)

     Options specific to classifier weka.classifiers.trees.J48:

     -U
      Use unpruned tree.

     -C <pruning confidence>
      Set confidence threshold for pruning.
      (default 0.25)

     -M <minimum number of instances>
      Set minimum number of instances per leaf.
      (default 2)

     -R
      Use reduced error pruning.

     -N <number of folds>
      Set number of folds for reduced error
      pruning. One fold is used as pruning set.
      (default 3)

     -B
      Use binary splits only.

     -S
      Don't perform subtree raising.

     -L
      Do not clean up after the tree has been built.

     -A
      Laplace smoothing for predicted probabilities.

     -Q <seed>
      Seed for random data shuffling (default 1).

Options after -- are passed to the designated classifier.

Specified by:
  `setOptions` in interface `OptionHandler`
Overrides:
  `setOptions` in class `RandomizableIteratedSingleClassifierEnhancer`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the Classifier.

Specified by:
  `getOptions` in interface `OptionHandler`
Overrides:
  `getOptions` in class `RandomizableIteratedSingleClassifierEnhancer`
Returns:
  an array of strings suitable for passing to setOptions

### desiredSizeTipText

public String desiredSizeTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### numIterationsTipText

public String numIterationsTipText()
Returns the tip text for this property

Overrides:
  `numIterationsTipText` in class `IteratedSingleClassifierEnhancer`
Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### artificialSizeTipText

public String artificialSizeTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### globalInfo

public String globalInfo()
Returns a string describing classifier

Returns:
  a description suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

public TechnicalInformation getTechnicalInformation()
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

Specified by:
  `getTechnicalInformation` in interface `TechnicalInformationHandler`
Returns:
  the technical information about this class

### getArtificialSize

public double getArtificialSize()
Factor that determines number of artificial examples to generate.

Returns:
  factor that determines number of artificial examples to generate

### setArtificialSize

public void setArtificialSize(double newArtSize)
Sets factor that determines number of artificial examples to generate.

Parameters:
  `newArtSize` - factor that determines number of artificial examples to generate

### getDesiredSize

public int getDesiredSize()
Gets the desired size of the committee.

Returns:
  the desired size of the committee

### setDesiredSize

public void setDesiredSize(int newDesiredSize)
Sets the desired size of the committee.

Parameters:
  `newDesiredSize` - the desired size of the committee

### getCapabilities

public Capabilities getCapabilities()
Returns default capabilities of the classifier.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `SingleClassifierEnhancer`
Returns:
  the capabilities of this classifier
See Also:
  - `Capabilities`

### buildClassifier

public void buildClassifier(Instances data) throws Exception
Build Decorate classifier

Overrides:
  `buildClassifier` in class `IteratedSingleClassifierEnhancer`
Parameters:
  `data` - the training data to be used for generating the classifier
Throws:
  `Exception` - if the classifier could not be built successfully

### distributionForInstance

public double[] distributionForInstance(Instance instance) throws Exception
Calculates the class membership probabilities for the given test instance.

Overrides:
  `distributionForInstance` in class `Classifier`
Parameters:
  `instance` - the instance to be classified
Returns:
  predicted class probability distribution
Throws:
  `Exception` - if distribution can't be computed successfully

### toString

public String toString()
Returns description of the Decorate classifier.

Overrides:
  `toString` in class `Object`
Returns:
  description of the Decorate classifier as a string

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Classifier`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - the options